/*
NOKIA MOBILE PHONES                                             CONFIDENTIAL
R&D Tampere
Bodyguard / DSP










            DSP SW Include Code Document - ANSI C







%full_name: tr_omap#1/incl/a_imumdrc.h/7 %

%full_filespec: a_imumdrc.h-7:incl:tr_omap#1 %

%date_created: Wed May 05 13:45:10 2004 %

%created by: %



?[[This template is dsp_sw_c_inc_templ.asm version 1

Main features:
- LEAD3 assembler compatible
- supports Continuus automatic fields
- ?[]? brackets indicate fields to be edited
- ?[[]]? brackets indicate notes that can be removed
]]?


Copyright (c) Nokia Mobile Phones. All rights reserved.

Change History:

NOTE: Duplicate the first block between the lines below and 
change the # signs of the lower one to % signs before checking 
the file into Continuus/CM.

Latest version is on top of the list
------------------------------------------------------------------------
Version: #version#
Date modified: #date_modified#
Derived by: #derived_by#
Status: -
Version notes:
-
------------------------------------------------------------------------
Version: 3
Date modified: Fri Mar 26 09:37:30 2004
Derived by: pasparta
Status: -
Version notes:
-
------------------------------------------------------------------------
Version: 0.1
Date modified: -
Derived by: -
Status: -
Version notes:
-
------------------------------------------------------------------------
*/
/*  CONTENTS

    1  ABSTRACT
        1.1  Description
        1.2  Notes

    2  INCLUDE FILES

    3  COMPILER FLAGS

    4  CONSTANTS

    5  MACROS

    6  DATA TYPES

    7  EXTERNAL DATA STRUCTURES

    8  FUNCTION PROTOTYPES
*/

/*  1  ABSTRACT

    1.1 Description

    This header defines all types, constants, and functions shared by all
    implementations of the MuMDRC module.

    1.2 Notes

*/
#ifndef A_IMUMDRC_H
#define A_IMUMDRC_H

/*  2  INCLUDE FILES */
/*
#include <std.h>
#include <ialg.h>
#include "a_type_def.h"
*/
/*  3 COMPILER FLAGS */


/*  4  CONSTANTS */

#define NUM_BANDS 5
#define LINE_SEGMENT_COUNT 5

/*  5  MACROS */


/*  6  DATA TYPES */

/*
* ======== IMUMDRC_Obj ========
* Every implementation of IMUMDRC *must* declare this structure as
* the first member of the implementation's object.
*/
/*
typedef struct IMUMDRC_Obj
{
  struct IMUMDRC_Fxns* fxns;
} IMUMDRC_Obj;
*/
/*
* ======== IMUMDRC_Handle ========
* This type is a pointer to an implementation's instance object.
*/
//typedef struct IMUMDRC_Obj* IMUMDRC_Handle;

/*
* ======== IMUMDRC_Params ========
* This structure defines the parameters necessary to create an
* instance of an MUMDRC object.
*
* Every implementation of IMUMDRC *must* declare this structure as
* the first member of the implementation's parameter structure.
*/
typedef struct IMUMDRC_Params
{
/* for QMF framework */
    short int maxDelayCompanderMs;
    unsigned short int SampleRate;

/* for hpfilter */
    unsigned short int max_nbr_iir_blocks;
  
/* for limiter */
    short int maxDelayLimiterMs;
  
} IMUMDRC_Params;

/*
* ======== IMUMDRC_Fxns ========
* All implementation's of MUMDRC must declare and statically
* initialize a constant variable of this type.
*/
/*
typedef struct IMUMDRC_Fxns
{
  IALG_Fxns ialg;
  Void (*Mumdrc)(IMUMDRC_Handle handle,
              int32 input_left[],
              int32 input_rigth[],
              int16 output_left[],
              int16 output_right[],
              int16 framelen);
  Void (*HPFilter)(IMUMDRC_Handle handle,
  			  int16 input[],
  			  int16 frame_len);
} IMUMDRC_Fxns;
*/
/*
* ======== IMUMDRC_Status ========
* The status structure defines the parameters that can be changed
* during real-time operation of the algorithm.
*/
typedef struct IMUMDRC_Status
{
/* for crossband control */
  short int linkCoeffSelf;
  short int linkCoeffOthers;

/* for limiter */
  short int lim_attCoeff;
  short int lim_relCoeff;
  long int limiterThreshold;  
  long int limGain;  
  
/* for attack and release time filtering */
  long int attCoeff[NUM_BANDS];
  long int relCoeff[NUM_BANDS];

/* for the average amplitude to gain calculation */
  long int levelLimits[NUM_BANDS][LINE_SEGMENT_COUNT];
  long int K[NUM_BANDS][LINE_SEGMENT_COUNT+1];
  long int A[NUM_BANDS][LINE_SEGMENT_COUNT+1];

/* for enable/disable MuMDRC algorithm */
// note this was bool16
    unsigned short int use_mumdrc;
  
/* for tracing */
  long int Gain[NUM_BANDS];
  long int amplitudes[NUM_BANDS]; 
  
} IMUMDRC_Status;

/*
* ======== IMUMDRC_HPFilt_Status ========
* The status structure defines the parameters that can be changed
* during real-time operation of the algorithm.
*/
typedef struct IMUMDRC_HPFilt_Status
{
  unsigned short int use_hpfilt;
  short int *coeffs;
} IMUMDRC_HPFilt_Status;

/*
* ======== IMUMDRC_Cmd ========
* The Cmd enumeration defines the control commands for the MUMDRC
* control method.
*/
typedef enum IMUMDRC_Cmd
{
  CHANGE_PARAMETERS,
  CHANGE_HPFILT_COEFFS,
  GET_PARAMETERS,
  GET_HPFILT_COEFFS
} IMUMDRC_Cmd;

/*  7  EXTERNAL DATA STRUCTURES */

/*
* ======== IMUMDRC_PARAMS ========
* Default instance creation parameters
*/
/*
extern IMUMDRC_Params IMUMDRC_PARAMS;
extern IMUMDRC_Status IMUMDRC_STATUS;
*/
/*  8  FUNCTION PROTOTYPES */

#endif 

/* End of File */
