/*
NOKIA RESEARCH CENTER                                             CONFIDENTIAL
Southwood
Roumen Popov










            DSP SW Include Code Document - ANSI C







%full_name: pcm_socket_node.h%

%full_filespec: MP3 socket node header file%

%date_created: 17.03.2004%

%created by: Roumen Popov%



Main features:
- LEAD3 assembler compatible
- supports Continuus automatic fields
- ?[]? brackets indicate fields to be edited
- ?[[]]? brackets indicate notes that can be removed
]]?


Copyright (c) Nokia Research Center. All rights reserved.


Change History:

NOTE: Duplicate the first block between the lines below and 
change the # signs of the lower one to % signs before checking 
the file into Continuus/CM.

Latest version is on top of the list
------------------------------------------------------------------------
Version: #version#
Date modified: #date_modified#
Derived by: #derived_by#
Status: -
Version notes:
-
------------------------------------------------------------------------
Version: %0.1%
Date modified: %08.03.2004%
Derived by: %Roumen Popov%
Status: -
Version notes:
-
------------------------------------------------------------------------
Version: 0.1
Date modified: -
Derived by: -
Status: -
Version notes:
-
------------------------------------------------------------------------
*/

/*  CONTENTS

    1  ABSTRACT
        1.1  Description
        1.2  Notes

    2  INCLUDE FILES

    3  COMPILER FLAGS

    4  CONSTANTS

    5  MACROS

    6  DATA TYPES

    7  EXTERNAL DATA STRUCTURES

    8  FUNCTION PROTOTYPES
*/

/*  1  ABSTRACT

    1.1 Description

	Provides constants and data types for the PCM socket nodes


    1.2 Notes

    ?[notes]?
    ?[[Any notes that may be relevant, open items, optimizations, etc.]]?
*/

#ifndef AUDIO_PP_SOCKET_NODE
#define AUDIO_PP_SOCKET_NODE
/*  2  INCLUDE FILES */
#include "a_igeq.h"
#include "a_imumdrc.h"
#include "audio_socket_node.h"
/*  3 COMPILER FLAGS */

/*  4  CONSTANTS */

//#define OUTPUT_AUDIO_FRAME_SIZE 576

#define INPUT_AUDIO_BUFFER_SIZE 480
#define OUTPUT_AUDIO_BUFFER_SIZE 480
/*
#define STREAM_BUFFER_SIZE 2000

#define BRIDGE_BUFFER_SIZE 4*STREAM_BUFFER_SIZE
*/
/*  5  MACROS */

/*  6  DATA TYPES */

typedef struct EQ_RUNTIME_PARAMS
{
  unsigned short int dsp_cmd;  //void not used here

  unsigned short int use_eq;  /* Enable/disable the equaliser */
   short int size; /* This is a void parameter, not used at all. Added for future 
	          algorithm compatibility */
 //  short int level_db_ptr[3]; /* Band levels */ // Added for the operation of the algorithm, don't write anything here
   
  unsigned short int order; /* Filter order */
  
 // short  int band_ptr[3]; /* Band limits */  // Added for the operation of the algorithm, don't write anything here
  short int bands; /* Number of bands */
  unsigned short int band[10]; /* Band limits */
  short int  level_db[10]; /* Band levels */
    unsigned short int alignment;  //void not used here
} EQ_RUNTIME_PARAMS;

/* audio socket node initialisation data */
/*
typedef struct audio_params_data
{
    Uns dsp_cmd; // void, not used here
    Uns audio_fmt;
    Uns sample_rate;
    Uns number_channels;
    Uns ds_stream_ID;
} AUDIO_PARAMS_DATA;
*/


typedef struct MUSICDRC_RUNTIME_PARAMS
{
  unsigned short int dsp_cmd;  /* DSP_CMD_SET_POSTPROC_EQ_PARAMS */
  unsigned short int alignment;  /*used for alignment purposes */
/* for crossband control */
   short int linkCoeffSelf;
   short int linkCoeffOthers;

/* for limiter */
   short int lim_attCoeff;
   short int lim_relCoeff;
  long int limiterThreshold;  
  long int limGain;  
  
/* for attack and release time filtering */
  long int attCoeff[NUM_BANDS];
  long int relCoeff[NUM_BANDS];

/* for the average amplitude to gain calculation */
  long int levelLimits[NUM_BANDS][LINE_SEGMENT_COUNT];
  long int K[NUM_BANDS][LINE_SEGMENT_COUNT+1];
  long int A[NUM_BANDS][LINE_SEGMENT_COUNT+1];

/* for enable/disable MuMDRC algorithm */
  unsigned short int use_mumdrc;  
  
/* for tracing */
  long int Gain[NUM_BANDS];
  long int amplitudes[NUM_BANDS]; 
  
} MUSICDRC_RUNTIME_PARAMS;


typedef struct MUSICDRC_HPFILTER_COEFFS
{
  unsigned short int dsp_cmd;  /* DSP_CMD_CHANGE_MUSICDRC_HPFILT_COEFFS */
  unsigned short int use_hpfilt;
   short int coeffs[32];
} MUSICDRC_HPFILTER_COEFFS;


typedef struct POSTPROCCESSING_BYPASS_DATA 
{
  unsigned short int dsp_cmd;  /* 0x20 */
  unsigned short int audio_pp_bypassed; /* if set to 1 audio post proc. will be bypassed */
} POSTPROCCESSING_BYPASS_DATA;

typedef struct POSTPROC_INIT_PARAMS
{
unsigned short int dsp_cmd;  /* DSP_CMD_SET_POSTPROC_INIT_PARAMS */
AUDIO_PARAMS_DATA audio_params; 
IGEQ_Params EQ_init_params;  // Equaliser init parameters
EQ_RUNTIME_PARAMS EQ_runtime_params; // Equaliser runtime parameters
IMUMDRC_Params MUSICDRC_init_params; // Music DRC init parameters.
MUSICDRC_RUNTIME_PARAMS MUSICDRC_runtime_params;
MUSICDRC_HPFILTER_COEFFS hp_filter_coeffs;
} POSTPROC_INIT_PARAMS;

typedef struct POSTPROC_ALGORITHM_PARAMS
{
unsigned short int dsp_cmd;  /* DSP_CMD_GET_POSTPROC_PARAMS */
unsigned short int status;
EQ_RUNTIME_PARAMS EQ_runtime_params;
MUSICDRC_RUNTIME_PARAMS MUSICDRC_runtime_params;
MUSICDRC_HPFILTER_COEFFS MUSICDRC_hpfilter_coeffs;
} POSTPROC_ALGORITHM_PARAMS;


/*
typedef enum eMP3DecDspMessages
{
	RMS_DSPMSG_MP3DEC_AUDIO_PARAMETERS = DSP_CMD_SET_PARAMS,
	RMS_DSPMSG_MP3DEC_PLAY = DSP_CMD_PLAY,
	RMS_DSPMSG_MP3DEC_PLAYCOMPLETED,
	RMS_DSPMSG_MP3DEC_PAUSE = DSP_CMD_PAUSE,
	RMS_DSPMSG_MP3DEC_STOP = DSP_CMD_STOP,
	RMS_DSPMSG_MP3DEC_RESET = 0x100
} eMP3DecDspMessages;
*/
typedef enum audio_pp_node_state
{
	AUDIO_PP_STATE_UNINITIALISED,
	AUDIO_PP_STATE_DEFAULT,
	AUDIO_PP_STATE_RESET,
	AUDIO_PP_STATE_PLAY,
	AUDIO_PP_STATE_DECODE,
	AUDIO_PP_STATE_PAUSE,
	AUDIO_PP_STATE_STOP
} audio_pp_node_state;

/*  7  EXTERNAL DATA STRUCTURES */

/*  8  FUNCTION PROTOTYPES */

#endif
/* End of File */
